#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dio.h>
#include <math.h>
#include <mriext.h>
#include "Screen.h"

MINISCRCONTAINER MiniScrContainer;
extern MINISCR *MiniScreenTab[1];

/*========================= About Mini Screen ======================*/
/*ʼһMINI_SCREENĬΪLayer A*/
DWORD _GetVDPAddress(WORD PNTAddress,short int PosX,short int PosY)
	{
	register WORD CurrentAddress;
	register DWORD VDPAddress;

	CurrentAddress=PNTAddress+((PosY*64)+PosX)*2;
	VDPAddress=(CurrentAddress & 0x3fff) | 0x4000;
	VDPAddress=(VDPAddress << 16) | (CurrentAddress>>14);
	return VDPAddress;
	}

void InitMiniScreen(MINISCRCONTAINER *lptrMiniScrContainer,BOOL bInitPNT)
	{
	InitMiniScreenEx(lptrMiniScrContainer,bInitPNT,0);
	}

void InitMiniScreenEx(MINISCRCONTAINER *lptrMiniScrContainer,BOOL bInitPNT,WORD EmptyCode)
	{
	memcpy(&MiniScrContainer,lptrMiniScrContainer,sizeof(MINISCRCONTAINER));
	MiniScrContainer.CurrentPGTCode=MiniScrContainer.StartPGTCode;
	MiniScrContainer.BlkNum=0;
	if(bInitPNT)
		{
		short int i;

		_WriteVDPRegister(15,0x02);
		/*----------- Clear PNT Area -----------*/
		VDPRegPortL=_GetVDPAddress(MiniScrContainer.PNTAddress,0,0);
		for(i=0; i<64*32; i++)	VDPDataPortW=(MiniScrContainer.StartPGTCode+EmptyCode) & 0x07ff;
		}
	}

short int AppendMiniScreenEx(MINISCR *lptrMiniScreen,short int ColorArea,BOOL bInitColor,WORD StartPGTCode)
	{
	short int i;
	short int j;

	if(MiniScrContainer.BlkNum>=MAX_MINISCRBLK)	return -1;

	j=MiniScrContainer.BlkNum;
	MiniScrContainer.ScrBlk[j].StartPGTCode=StartPGTCode;
	MiniScrContainer.ScrBlk[j].PGTSize=lptrMiniScreen->PGTSize;
	MiniScrContainer.ScrBlk[j].ColorArea=ColorArea;
	MiniScrContainer.ScrBlk[j].lptrMiniScr=lptrMiniScreen;
	/*-------------------- Translate PGT Code -----------------*/
	_DirectDMATranslate(StartPGTCode*32,lptrMiniScreen->lptrPGTTab,lptrMiniScreen->PGTSize*32,2,0x00);
	if(bInitColor)
		{
		VDPRegPortL=0xc0000000+((DWORD)(ColorArea*32) << 16);			/*ɫ̣ɫ*/
		for(i=0; i<16; i++) VDPDataPortW=lptrMiniScreen->lptrPalette[i];
		}
	MiniScrContainer.BlkNum++;
	return j;
	}

short int AppendMiniScreen(MINISCR *lptrMiniScreen,short int ColorArea,BOOL bInitColor)
	{
	short int ReturnVal;
	if((MiniScrContainer.CurrentPGTCode + lptrMiniScreen->PGTSize) > MiniScrContainer.MaxPGTSize) return -1;
	ReturnVal=AppendMiniScreenEx(lptrMiniScreen,ColorArea,bInitColor,MiniScrContainer.CurrentPGTCode);
	MiniScrContainer.CurrentPGTCode += lptrMiniScreen->PGTSize;
	return ReturnVal;
	}

void PutMiniScrBlk(short int PosX,short int PosY,short int BlkIndex,short int ItemIndex,
	WORD PNTPri)
	{
	PutMiniScrBlkEx(PosX,PosY,BlkIndex,ItemIndex,PNTPri,MiniScrContainer.PNTAddress);
	}

void PutMiniScrBlkEx(short int PosX,short int PosY,short int BlkIndex,short int ItemIndex,
	WORD PNTPri,WORD PNTAddress)
	{
	short int x;
	short int y;
	MINISCR *lptrMiniScr;
	PNTBLK *lptrPNTBlk;
	WORD ColorArea;
	WORD StartPNTCode;
	short int Index;

	PNTPri=PNTPri & 0x8000;
	lptrMiniScr=MiniScrContainer.ScrBlk[BlkIndex].lptrMiniScr;
	lptrPNTBlk=lptrMiniScr->lptrPNTBlk[ItemIndex];
	StartPNTCode=MiniScrContainer.ScrBlk[BlkIndex].StartPGTCode;
	ColorArea=(MiniScrContainer.ScrBlk[BlkIndex].ColorArea & 0x03) << 13;
	_WriteVDPRegister(15,0x02);
	for(y=0,Index=0; y<lptrPNTBlk->nSizeY; y++)
		{
		VDPRegPortL=_GetVDPAddress(PNTAddress,PosX,y+PosY);
		for(x=0; x<lptrPNTBlk->nSizeX; x++,Index++)
			VDPDataPortW=((lptrPNTBlk->PNTCode[Index] + StartPNTCode) & 0x07ff) | ColorArea | PNTPri;
		}
	}

void GetMiniScrInfor(short int BlkIndex,MINISCRBLK *lptrMiniScrBlk)
	{
	lptrMiniScrBlk->StartPGTCode= MiniScrContainer.ScrBlk[BlkIndex].StartPGTCode;
	lptrMiniScrBlk->PGTSize		= MiniScrContainer.ScrBlk[BlkIndex].PGTSize;
	lptrMiniScrBlk->ColorArea	= MiniScrContainer.ScrBlk[BlkIndex].ColorArea;
	lptrMiniScrBlk->Reserve		= MiniScrContainer.ScrBlk[BlkIndex].Reserve;
	lptrMiniScrBlk->lptrMiniScr	= MiniScrContainer.ScrBlk[BlkIndex].lptrMiniScr;
	}

void GetMiniScrSize(short int BlkIndex,short int ItemIndex,SIZE *lptrSize)
	{
	MINISCR *lptrMiniScr;
	PNTBLK	*lptrPNTBlk;

	lptrMiniScr=MiniScrContainer.ScrBlk[BlkIndex].lptrMiniScr;
	lptrPNTBlk=lptrMiniScr->lptrPNTBlk[ItemIndex];
	lptrSize->cx=lptrPNTBlk->nSizeX;
	lptrSize->cy=lptrPNTBlk->nSizeY;
	}

WORD *GetMiniPalette(short int BlkIndex)
	{
	return MiniScrContainer.ScrBlk[BlkIndex].lptrMiniScr->lptrPalette;
	}

void DestoryMiniScreen(void)
	{
	}


