#include "DIO.h"
#include <Debug.h>

typedef struct tagDIOPNT {				/*ӲPNT*/
	WORD Reserve1:6;
	WORD vPosition:10;

	WORD Reserve2:4;
	WORD hSize:2;
	WORD vSize:2;
	WORD Reserve3:1;
	WORD NextLink:7;

	WORD Pri:1;
	WORD ColorArea:2;
	WORD vMirror:1;
	WORD hMirror:1;
	WORD PGTIndex:11;

	WORD Reserve4:7;
	WORD hPosition:9;
	}DIOPNT;

typedef struct tagUnitBlock {
	WORD RefX,RefY;
	BYTE SizeX,SizeY;			/*PNTСPatten*/
	WORD UnitID;				/*PNTľݡ*/
	}UNITBLK;

typedef struct tagDioLib {
	WORD PaletteID;			/*ɫ*/
	WORD UnitTableSize;		/*PNTĸ*/
	UNITBLK UnitBlk[1];
	}DIOLIB;

typedef struct tagUnitConfig {
	WORD UnitID;				/*ԭʼUnitIDֵ*/
	BYTE Size;
	BYTE Reserve;
	}UNITBUFFER;

UNITBUFFER OldUnitRef[MAX_REFSIZE];
UNITBUFFER NewUnitRef[MAX_REFSIZE];
/*------------------  Global  --------------------*/
short int RefTableSize;
short int RefFirstIndex;

WORD RefUnitID[MAX_REFSIZE];
WORD RefSize[MAX_REFSIZE];
WORD RefPGTPoint[MAX_REFSIZE];
BYTE RefUsedCount[MAX_REFSIZE];
short int RefNextIndex[MAX_REFSIZE];
/*------------------------------------------------*/
/*ڵһʼǰɡ*/
short int StaticUnitNum;
short int StaticSprNum;
WORD StaticSprID[MAX_DIONUM];
WORD StaticStartPGT[MAX_DIONUM];
WORD StaticRefPGT[MAX_REFSIZE];
/*------------------------------------------------*/

DIO DIOTable[MAX_DIONUM];		/*Global*/
DIO OldDIOTable[MAX_DIONUM];

DIOINFOR DIOInfor;

extern BYTE SPPGTTable[];
extern WORD SP_Palette[];
extern DIOLIB *DIOLib[];
/*extern WORD *UnitLib[];*/

DIOPNT	lpPNTTemp[80];

short int MaxIndex;

void InitDIO(DIOINFOR *lpDIOInfor)
	{
	int i;

	memcpy(&DIOInfor,lpDIOInfor,sizeof(DIOINFOR));
	RefTableSize=MAX_REFSIZE;		
	RefFirstIndex=0;
	for(i=0; i<MAX_REFSIZE; i++)
		{
		RefSize[i]=0;
		RefUsedCount[i]=0;
		RefNextIndex[i]=-1;
		RefUnitID[i]=0xffff;
		StaticRefPGT[i]=0xffff;
		}
	RefSize[0]=DIOInfor.PGTSize;
	RefPGTPoint[0]=DIOInfor.PGTStartAddress;

	memset(DIOTable,0xff,sizeof(DIO)*MAX_DIONUM);
	memset(OldDIOTable,0xff,sizeof(DIO)*MAX_DIONUM);
	memset(lpPNTTemp,0x00,sizeof(DIOPNT)*80);

	_WriteVDPRegister(5,(BYTE)(DIOInfor.InforStartAddress>>9) & 0xfe);	
		/*Set DIO attribute table address*/
	MaxIndex=0;
	StaticUnitNum=0;
	StaticSprNum=0;
	}

void SetDIOPalette(short int ColorArea,WORD *lpPalette)
	{
	short int i;

	VDPRegPortL=0xc0000000+(DWORD)((DWORD)(ColorArea*32)<<16);			/*ɫ*/
    for(i=0; i<16; i++) VDPDataPortW=lpPalette[i];
	}

void DestroyDIO(void)
	{
	}

short int AllocDIO(void)
	{
	short int SprIndex;
	short int i;

	for(SprIndex=0; SprIndex<MAX_DIONUM && DIOTable[SprIndex].DIOCode!=0xffff; SprIndex++);
	if(SprIndex>=MAX_DIONUM) return -1;
	DIOTable[SprIndex].x=0;
	DIOTable[SprIndex].y=0;
	DIOTable[SprIndex].SprPri=0;
	DIOTable[SprIndex].DIOCode=0;
	if((SprIndex+1)>MaxIndex)	
		MaxIndex=SprIndex+1;
	else
		{
		for(i=MAX_DIONUM-1; i>=0 && DIOTable[i].DIOCode==0xffff; i--);
		MaxIndex=i+1;
		}
	return SprIndex;
	}

WORD SetDIOPri(short int SprIndex,WORD NewSprPri)
	{
	WORD SprPriTemp;
	
	SprPriTemp=DIOTable[SprIndex].SprPri;
	if(NewSprPri!=DIOTable[SprIndex].SprPri)
		{
		DIOTable[SprIndex].SprPri=NewSprPri;
		}
	return SprPriTemp;
	}

void DisplayDIO(void)
	{	
	short int OldListSize;
	short int NewListSize;
	WORD OldSprList[MAX_DIONUM];
	WORD NewSprList[MAX_DIONUM];
	UNITBUFFER *lpOldUnitTemp;
	UNITBUFFER *lpNewUnitTemp;
	short int SprPriTable[MAX_DIONUM];
	register short int *lptrSprPri1;
	short int *lptrSprPri2;
	short int DIONum;
	short int i,j,k;
	short int SrcIndex,DestIndex;
	short int SprIndex;
	DIOLIB *lpFrame;
	short int OldUnitNum;
	short int NewUnitNum;
	short int SprRefIndex;
	short int PNTNum;
	WORD *lpUnitTemp;
	register DIOPNT *lpPNTBuffer;
	short int PNTIndex;

	OldListSize=0;
	NewListSize=0;
	for(i=0; i<MaxIndex; i++)
		{
		if(OldDIOTable[i].DIOCode!=0xffff && (StaticSprNum==0 ||
			memchw(StaticSprID,OldDIOTable[i].DIOCode,StaticSprNum)>=StaticSprNum))
			{
			j=OldListSize==0 ? 0 : memchw(OldSprList,OldDIOTable[i].DIOCode,OldListSize);
			if(j>=OldListSize)
				{
				OldSprList[j]=OldDIOTable[i].DIOCode;
				OldListSize++;
				}
			}
		if(DIOTable[i].DIOCode!=0xffff && (StaticSprNum==0 || 
			memchw(StaticSprID,DIOTable[i].DIOCode,StaticSprNum)>=StaticSprNum))
			{
			j=NewListSize==0 ? 0 : memchw(NewSprList,DIOTable[i].DIOCode,NewListSize);
			if(j>=NewListSize)
				{
				NewSprList[j]=DIOTable[i].DIOCode;
				NewListSize++;
				}
			}
		}

	/*ȥδıĶ*/
	for(i=0; i<NewListSize; i++)
		{
		j=memchw(OldSprList, NewSprList[i], OldListSize);
		if(j < OldListSize)
			{
			NewSprList[i]=0xffff;
			OldSprList[j]=0xffff;
			}
		}

	/*#################### Step1: жظUnitCode ####################*/
	OldUnitNum=0;
	NewUnitNum=0;

	/*ɶͳ*/
	for(k=0; k<OldListSize; k++)
		{
		if(OldSprList[k]==0xffff)	continue;
		lpFrame=DIOLib[OldSprList[k]];

		for(i=0; i<lpFrame->UnitTableSize; i++)
			{
			j=OldUnitNum==0 ? 0 : memchw(OldUnitRef,lpFrame->UnitBlk[i].UnitID,OldUnitNum);
            if(j>=OldUnitNum)
				{
                OldUnitRef[j].UnitID=lpFrame->UnitBlk[i].UnitID;
                OldUnitRef[j].Size=lpFrame->UnitBlk[i].SizeX*lpFrame->UnitBlk[i].SizeY;
				OldUnitNum++;
				}
			}
		}
	/*¶UnitCode*/
	for(k=0; k<NewListSize; k++)
		{
		if(NewSprList[k]==0xffff)	continue;
		lpFrame=DIOLib[NewSprList[k]];

		for(i=0; i<lpFrame->UnitTableSize; i++)
			{
			j=NewUnitNum==0 ? 0 : memchw(NewUnitRef,lpFrame->UnitBlk[i].UnitID,NewUnitNum);
			if(j>=NewUnitNum)
				{
                NewUnitRef[j].UnitID=lpFrame->UnitBlk[i].UnitID;
                NewUnitRef[j].Size=lpFrame->UnitBlk[i].SizeX*lpFrame->UnitBlk[i].SizeY;
				NewUnitNum++;
				}
			}
		}		

	/*######################## Step2: ɾ׷Ӷ #####################*/
/*	for(i=0,lpNewUnitTemp=NewUnitRef; i<NewUnitNum; i++,lpNewUnitTemp++)
		{
		j=memchw(OldUnitRef, lpNewUnitTemp->UnitID, OldUnitNum);
		if(j < OldUnitNum)
			{
			lpNewUnitTemp->UnitID=0xffff;
			OldUnitRef[j].UnitID=0xffff;
			}
		}*/

	/*####################### Step3: ִ׷Ӳ #######################*/
	for(i=0,lpNewUnitTemp=NewUnitRef; i<NewUnitNum; i++,lpNewUnitTemp++)
		{
		/*IDǷѾ*/
		if(lpNewUnitTemp->UnitID==0xffff)	continue;
		for(SprRefIndex=RefFirstIndex;SprRefIndex!=-1;SprRefIndex=RefNextIndex[SprRefIndex])
			if(RefUnitID[SprRefIndex]==lpNewUnitTemp->UnitID) break;
		if(SprRefIndex!=-1) 
			RefUsedCount[SprRefIndex]++;					/*ҵһѾڵID*/
		else
			{												/*µUnitID*/
			/*Ѱ޴СʵĿտ*/
			short int EmptyBlkSize;
			short int EmptySprRefIndex;

			EmptyBlkSize=0;
			EmptySprRefIndex=-1;
			for(SprRefIndex=RefFirstIndex; SprRefIndex!=-1;)
				{
				if(RefUsedCount[SprRefIndex]==0)			/*һδõĿտ*/
					{
					if(EmptyBlkSize==0)	
						if(RefSize[SprRefIndex]==lpNewUnitTemp->Size)	/*ҵһСʵĿ*/
							break;	
						else
							EmptySprRefIndex=SprRefIndex;
					EmptyBlkSize=EmptyBlkSize+RefSize[SprRefIndex];

					if(EmptyBlkSize>=lpNewUnitTemp->Size)	
						{			/*ҵһ¸ÿռ䣬ϲÿտ鼴пտ顣*/
						EmptyBlkSize=0;
						SprRefIndex=EmptySprRefIndex;
						while(SprRefIndex!=-1 && RefUsedCount[SprRefIndex]==0)
							{
							EmptyBlkSize+=RefSize[SprRefIndex];
							RefSize[SprRefIndex]=0;
							RefUnitID[SprRefIndex]=0xffff;
							SprRefIndex=RefNextIndex[SprRefIndex];
							}
						RefSize[EmptySprRefIndex]=EmptyBlkSize;
						RefNextIndex[EmptySprRefIndex]=SprRefIndex;
						SprRefIndex=EmptySprRefIndex;
						break;
						}
					}
				else
					EmptyBlkSize=0;
				SprRefIndex=RefNextIndex[SprRefIndex];
				}
			_DEBUGLOOP_(SprRefIndex==-1);	/*SprRef*/
			/*Զռзָ*/
			if(RefSize[SprRefIndex]>lpNewUnitTemp->Size)
				{
				/*һյSprRef*/
				for(j=0; j<RefTableSize && RefSize[j]!=0; j++);
				_DEBUGLOOP_(j>=RefTableSize);	/*DioRefTable */
				RefPGTPoint[j]=RefPGTPoint[SprRefIndex]+lpNewUnitTemp->Size;
				RefUnitID[j]=0xffff;
				RefUsedCount[j]=0;
				RefSize[j]=RefSize[SprRefIndex]-lpNewUnitTemp->Size;
				RefNextIndex[j]=RefNextIndex[SprRefIndex];
				RefSize[SprRefIndex]=lpNewUnitTemp->Size;
				RefNextIndex[SprRefIndex]=j;
				}
			RefUnitID[SprRefIndex]=lpNewUnitTemp->UnitID;
			RefUsedCount[SprRefIndex]=1;
			/*PGT...*/			
			_DirectDMATranslate(RefPGTPoint[SprRefIndex]*32,SPPGTTable+lpNewUnitTemp->UnitID*32,
				lpNewUnitTemp->Size*32,2,0);
			}
		}
	/*####################### Step4: ִɾ #######################*/
	for(i=0,lpOldUnitTemp=OldUnitRef; i<OldUnitNum; i++,lpOldUnitTemp++)
		{
		for(SprRefIndex=RefFirstIndex; SprRefIndex!=-1; 
			SprRefIndex=RefNextIndex[SprRefIndex])
			if(RefUnitID[SprRefIndex]==lpOldUnitTemp->UnitID)
				{
				RefUsedCount[SprRefIndex]--;
				break;
				}
		}

	/*################## Step5: ἰPNT ###################*/
	PNTNum=0;
	for(i=0,DIONum=0; i<MaxIndex; i++)
		if(DIOTable[i].DIOCode!=0xffff)	SprPriTable[DIONum++]=i;

	lptrSprPri1=SprPriTable;
	for(i=0; i<DIONum-1; i++,lptrSprPri1++)
		{
		SrcIndex=*lptrSprPri1;
		lptrSprPri2=SprPriTable+i+1;
		for(j=i+1; j<DIONum; j++,lptrSprPri2++)
			{
			DestIndex=*lptrSprPri2;
			if(DIOTable[DestIndex].SprPri > DIOTable[SrcIndex].SprPri)
				{
				SrcIndex=*lptrSprPri2;
				*lptrSprPri2=*lptrSprPri1;
				*lptrSprPri1=SrcIndex;
				}
			}
		}

	PNTIndex=0;
	lpPNTBuffer=lpPNTTemp;
	lptrSprPri1=SprPriTable;
	for(k=0; k<DIONum && PNTIndex<80; k++,lptrSprPri1++)
		{
		register BYTE ColorArea;
		register BYTE Pri;
		register UNITBLK *lpUnitBlk;
		register DIO *lptrDIOTable;
		short int RefIDIndex;

		lptrDIOTable=DIOTable+(*lptrSprPri1);
		ColorArea=lptrDIOTable->ColorArea & 0x03;
		Pri=lptrDIOTable->SprPri>=0x8000 ? 1 : 0;
		lpFrame=DIOLib[lptrDIOTable->DIOCode];
		lpUnitBlk=lpFrame->UnitBlk;
		PNTNum+=lpFrame->UnitTableSize;
		if(StaticSprNum!=0 && (RefIDIndex=memchw(StaticSprID,lptrDIOTable->DIOCode,StaticSprNum))<StaticSprNum)
			{
			register WORD *lptrStaticPGT;
			lptrStaticPGT=StaticRefPGT+StaticStartPGT[RefIDIndex];
			for(i=0; i<lpFrame->UnitTableSize; i++,lpUnitBlk++,lptrStaticPGT++)
				{
				lpPNTBuffer->hPosition=
					lptrDIOTable->x+(short int)(lpUnitBlk->RefX);
				lpPNTBuffer->vPosition=
					lptrDIOTable->y+(short int)(lpUnitBlk->RefY);
/*				lpPNTBuffer->hMirror=0;
				lpPNTBuffer->vMirror=0;*/
				lpPNTBuffer->hSize=lpUnitBlk->SizeX-1;
				lpPNTBuffer->vSize=lpUnitBlk->SizeY-1;
				lpPNTBuffer->ColorArea=ColorArea;
				lpPNTBuffer->Pri=Pri;
				lpPNTBuffer->PGTIndex=*lptrStaticPGT;
				lpPNTBuffer->NextLink=++PNTIndex;
				lpPNTBuffer++;
				}
			}
		else
			{
			for(i=0; i<lpFrame->UnitTableSize; i++,lpUnitBlk++)
				{				
				/*lpFrame->UnitBlk[i].UnitID*/
				for(SprRefIndex=RefFirstIndex; SprRefIndex!=-1;
					SprRefIndex=RefNextIndex[SprRefIndex])
					if(RefUnitID[SprRefIndex]==lpUnitBlk->UnitID)
						{
						lpPNTBuffer->hPosition=
							lptrDIOTable->x+(short int)(lpUnitBlk->RefX);
						lpPNTBuffer->vPosition=
							lptrDIOTable->y+(short int)(lpUnitBlk->RefY);
/*						lpPNTBuffer->hMirror=0;
						lpPNTBuffer->vMirror=0;*/
						lpPNTBuffer->hSize=lpUnitBlk->SizeX-1;
						lpPNTBuffer->vSize=lpUnitBlk->SizeY-1;
						lpPNTBuffer->ColorArea=ColorArea;
						lpPNTBuffer->Pri=Pri;
						lpPNTBuffer->PGTIndex=RefPGTPoint[SprRefIndex];
						lpPNTBuffer->NextLink=++PNTIndex;
						lpPNTBuffer++;
						break;
						}
				}
			}
		}
	if(PNTIndex!=0)	lpPNTTemp[PNTIndex-1].NextLink=0;
	_DirectDMATranslate(DIOInfor.InforStartAddress,lpPNTTemp,PNTNum * sizeof(DIOPNT),2,0);
/*	free(lpPNTTemp);*/
	memcpy(OldDIOTable,DIOTable,sizeof(DIO)*MaxIndex);
	}

BOOL PreloadSprite(PRELOAD *lptrPreloadTab)
	{
	short int i,j;
	DIOLIB *lpFrame;
	short int TotalPNTSize;
	short int SprIndex;
	WORD UnitIDTab[MAX_REFSIZE];
	WORD UnitIDSize[MAX_REFSIZE];
	WORD UnitPGTRef[MAX_REFSIZE];
	short int RefIDSize;
	short int RefIDSizeTemp;
	short int PGTSize;
	short int PGTSizeTemp;
	short int UnitNum;

	RefIDSize=0;
	PGTSize=0;
	StaticSprNum=0;
	for(SprIndex=0; SprIndex<lptrPreloadTab->nSize; SprIndex++)
		{
		lpFrame=DIOLib[lptrPreloadTab->Table[SprIndex]];
		RefIDSizeTemp=RefIDSize;
		PGTSizeTemp=PGTSize;
		for(i=0; i<lpFrame->UnitTableSize; i++)
			{
			for(j=0; j<RefIDSizeTemp && UnitIDTab[j]!=lpFrame->UnitBlk[i].UnitID; j++);
			if(j>=RefIDSizeTemp)
				{
				PGTSizeTemp+=(lpFrame->UnitBlk[i].SizeX*lpFrame->UnitBlk[i].SizeY);
				if(PGTSizeTemp>=lptrPreloadTab->StaticPGTSize)	break;
				UnitIDTab[j]=lpFrame->UnitBlk[i].UnitID;
				UnitIDSize[j]=lpFrame->UnitBlk[i].SizeX*lpFrame->UnitBlk[i].SizeY;
				RefIDSizeTemp++;
				}
			}
		if(i>=lpFrame->UnitTableSize)
			{
			RefIDSize=RefIDSizeTemp;
			PGTSize=PGTSizeTemp;
			StaticSprID[StaticSprNum++]=lptrPreloadTab->Table[SprIndex];
			}
		}
	for(i=0; i<RefIDSize; i++)
		{
		_DirectDMATranslate(RefPGTPoint[0]*32,SPPGTTable+UnitIDTab[i]*32,UnitIDSize[i]*32,2,0);
		UnitPGTRef[i]=RefPGTPoint[0];
		RefPGTPoint[0]+=UnitIDSize[i];
		RefSize[0]=RefSize[0]-UnitIDSize[i];
		}
	UnitNum=0;
	for(SprIndex=0; SprIndex<StaticSprNum; SprIndex++)
		{
		short int PGTIndex;
		lpFrame=DIOLib[StaticSprID[SprIndex]];
		StaticStartPGT[SprIndex]=UnitNum;
		for(i=0; i<lpFrame->UnitTableSize; i++)
			{
			for(j=0; j<RefIDSize && UnitIDTab[j]!=lpFrame->UnitBlk[i].UnitID; j++);
			StaticRefPGT[UnitNum++]=UnitPGTRef[j];
			}
		}
	return TRUE;
	}
