
/************************************************************************/
/* Copyright (c) 1988-1991 Microtec Research, Inc.                      */
/* ALL RIGHTS RESERVED                                                  */
/************************************************************************/
/*  <stdlib.h>  Microtec Research, Inc. ANSI C Compiler  */
/* %W% %G% */

/*
	11/10/93 jpc:   removed all #? directives; preprocessing not needed
	12/03/91 jpc:   added C++ definition for NULL
	05/17/91 jpc:   added 040 support
	11/15/90 jpc:   Added #define for NULL as per ANSI
	04/12/90 lc:    Added c++ support.
	09/16/89 jpc:   Added #? directives to control 68K '881 support
    1/28/99 tommyxie: Modify all lib for SEGA.(tomsoft@pub.xaonline.com)
*/

#ifndef __STDLIB_H
#define __STDLIB_H      1

typedef unsigned int DWORD;
typedef short unsigned int WORD;
typedef unsigned char BYTE;
typedef unsigned long LONG;
typedef unsigned char BOOL;

typedef struct tagRECT {
    short int left,top,right,bottom;
    }RECT;

typedef struct tagPoint {
    short int x,y;
    }POINT;

typedef struct tagSize {
    short int cx,cy;
    }SIZE;

#define TRUE    1
#define FALSE   0

/*----------------------------------------------------
 * typedef struct tagDMAItem {
 *              WORD    _IncRegister;
 *              WORD    _LengthL;
 *              WORD    _LengthH;
 *              WORD    _SrcAddressL;
 *              WORD    _SrcAddressM;
 *              WORD    _SrcAddressH;
 *              LONG    _DestAddress;
 *              BYTE    _DMAMode;
 *              struct tagDMAItem *lptrNextItem;
 *              BYTE    Data[1];
 *              }DMAITEM;
 *      _DMAMode:
 *              +---+---+---+---++---+---+---+---+
 *                |   |  \--v--/  \------v------/
 *                |       |             |                        |
 *                |       |             |                        +------->Accessed Mode: 00-05
 *                |       |             +-------------------->Ext.
 *                |       +-------------------------->Auto Free.
 *                +------------------------------>Single Flag.
 *----------------------------------------------------*/
typedef struct tagDMAItem {
	WORD    _IncRegister;
	WORD    _LengthL;
	WORD    _LengthH;
	WORD    _SrcAddressL;
	WORD    _SrcAddressM;
	WORD    _SrcAddressH;
	LONG    _DestAddress;
	struct tagDMAItem *lptrNextItem;
	WORD    *lptrSrcData;
	BYTE    _DMAMode;
	BYTE    _SystemReserve;
	WORD    Data[1];
	}DMAITEM;

#define CHAIN_SIZE      8

#define VRAM_WRITE      0x00
#define CRAM_WRITE      0x01
#define VSRAM_WRITE     0x02
#define VRAM_READ       0x03
#define CRAM_READ       0x04
#define VSRAM_READ      0x05

#define VDPRegPortW *(WORD *)0xc00004
#define VDPRegPortL *(LONG *)0xc00004
#define VDPDataPortW *(WORD *)0xc00000
#define VDPDataPortL *(LONG *)0xc00000

void Delay(WORD Timer);

typedef struct tagSingleScreen {
	WORD SizeX,SizeY,PGTSize;
	WORD *lpPalette;
	WORD *lpPNT;
	WORD *lpPGT;
	}SINGLESCREEN;

#ifndef _AT_VDP_SOURCE
extern void _ClearVDPRAM(void);
extern void _InitVDPRegister(void);
extern void _WriteVDPRegister(WORD RegisterNo,BYTE RegisterCode);
extern BYTE _ReadVDPRegister(WORD RegisterNo);
extern void _DirectDMATranslate(WORD DMAAddress,WORD *lptrSourceAddress,WORD nSize,
	WORD IncStep,BYTE Mode);
extern void _HardDMATranslate(WORD DMAAddress,WORD *lptrSourceAddress,WORD nSize,
	WORD IncStep,BYTE Mode);
extern short int DisplaySingleScreen(SINGLESCREEN *lpScreen);
extern short int DisplaySingleScreenEx(SINGLESCREEN *lpScreen,BOOL bHighPri);
extern short int _FillScreenData(SINGLESCREEN *lpScreen,WORD StartPGT,WORD StartPNT,
	WORD ColorArea,short int ScrLayer,BOOL bHighPri);
extern void gprintf(short int x,short int y, const char *fmt);
extern void SetTextMode();
extern void _ClearVRAM(WORD DMAAddress,WORD nSize);
extern short int _FillScreenData(SINGLESCREEN *lpScreen,WORD StartPGT,WORD StartPNT,WORD ColorArea,
	short int ScrLayer,BOOL bHighPri);
#endif

#if __STDC__

    #ifndef __STDDEF_H
	typedef _WCHAR_T wchar_t;
    #endif /* __STDDEF_H */

    #if ! (__STDDEF_H || __STDIO_H || __STRING_H || __TIME_H)

	#ifdef _sun
	    typedef int size_t;
	#else
	    typedef _SIZE_T size_t;
	#endif

    #endif /* ! (__STDDEF_H || __STDIO_H || __STRING_H || __TIME_H) */

#endif /* __STDC__ */

typedef struct div_t {int  quot, rem;} div_t;
typedef struct ldiv_t {long quot, rem;} ldiv_t;

#define EXIT_FAILURE    1
#define EXIT_SUCCESS    0
#define RAND_MAX        0x7FFF
#define MB_CUR_MAX      1

#if __cplusplus
    #define     NULL            (0)
#else
    #define     NULL            ((void *)0)
#endif

#if __STDC__

    #if __cplusplus
	extern "C" {
    #endif

    extern double    atof(const char *);
    extern int       atoi(const char *);
    extern long      atol(const char *);
    extern double    strtod(const char *, char **);
    extern long      strtol(const char *, char **, int);
    extern unsigned  long strtoul(const char *, char **, int);
    extern int       rand(void);
    extern void      srand(unsigned);
	extern void             _FreeAllMemory(void);
    extern void     *calloc(size_t, size_t);
    extern void      free(void *);
    extern void     *malloc(size_t);
    extern void     *realloc(void *, size_t);
    extern int       atexit(void (*)(void));
    extern void      exit(int);
    extern char     *getenv(const char *);
    extern int       system(const char *);
    extern void     *bsearch(const void *, const void *, size_t,
			size_t, int (*)(const void *, const void *));
    extern void      qsort(void *, size_t, size_t,
			int (*)(const void *, const void *));
    extern int       abs(int);
    extern div_t     div(int, int);
    extern long      labs(long);
    extern ldiv_t    ldiv(long, long);
    extern int       mblen(const char *, size_t);
    extern int       mbtowc(wchar_t *, const char *, size_t);
    extern int       wctomb(char *, wchar_t);
    extern size_t    mbstowcs(wchar_t *, const char *, size_t);
    extern size_t    wcstombs(char *, const wchar_t *, size_t);

    #if __cplusplus
	}
    #endif

#else /* __STDC__ */

    extern double    atof();
    extern int       atoi();
    extern long      atol();
    extern double    strtod();
    extern long      strtol();
    extern unsigned  long strtoul();
    extern int       rand();
    extern void      srand();
	extern void             _FreeAllMemory();
    extern void     *calloc();
    extern void      free();
    extern void     *malloc();
    extern void     *realloc();
    extern int       atexit();
    extern void      exit();
    extern char     *getenv();
    extern int       system();
    extern void     *bsearch();
    extern void      qsort();
    extern int       abs();
    extern div_t     div();
    extern long      labs();
    extern ldiv_t    ldiv();
    extern int       mblen();
    extern int       mbtowc();
    extern int       wctomb();
    extern int       mbstowcs();
    extern int       wcstombs();

#endif  /* ! __STDC__ */

#endif /* end __STDLIB_H */
