
/************************************************************************/
/* Copyright (c) 1988-1991 Microtec Research, Inc.			*/
/* ALL RIGHTS RESERVED							*/
/************************************************************************/
/*  <stdio.h>	Microtec Research, Inc. ANSI C Compiler  */
/* %W% %G% */

#ifndef __STDIO_H	/* avoid multiple inclusions */
#define __STDIO_H	1

#define KEY_START   0x8000
#define KEY_A       0x4000
#define KEY_C       0x2000
#define KEY_B       0x1000
#define KEY_RIGHT   0x0800
#define KEY_LEFT    0x0400
#define KEY_DOWN    0x0200
#define KEY_UP      0x0100
#define KEY_MODE    0x0008
#define KEY_X       0x0004
#define KEY_Y       0x0002
#define KEY_Z       0x0001

extern unsigned short int Key1Port;
extern unsigned short int Key2Port;
extern unsigned short int Key1Down;
extern unsigned short int Key2Down;

#if __STDC__

    typedef unsigned long fpos_t;

    #if ! (__STDDEF_H || __STDLIB_H || __STRING_H || __TIME_H)

	#ifdef _sun
	    typedef int size_t;
	#else
	    typedef _SIZE_T size_t;
	#endif

    #endif /* ! (__STDDEF_H || __STDLIB_H || __STRING_H || __TIME_H) */

#endif /* __STDC__ */

#ifndef __STDARG_H

    #if _MCC80 || _MCC960

	typedef struct	{
	    char *list;
	    int  arg;
	    } va_list;

    #else

	typedef char *va_list;

    #endif

#endif /* __STDARG_H */

#if __cplusplus
    #define	NULL		(0)
#else
    #define	NULL		((void *)0)
#endif

#ifdef __STDC__

    #if __cplusplus
	extern "C" {
    #endif

    extern int    sprintf(char *, const char *, ...);
    extern int    sscanf(const char *, const char *, ...);
    extern int    vsprintf(char *, const char *, va_list);

    #if __cplusplus
	}
    #endif

#else /* !__STDC__ */

    extern int    sprintf();
    extern int    sscanf();
    extern int    vsprintf();

#endif /* __STDC__ */

#endif /* ifndef __STDIO_H */

